QGIS Server 3.4 broken on Windows
Status: Feedback

Priority: High

Assignee:

Category: QGIS Server

Affected QGIS version:3.4.4 Regression?: Yes

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 28692

Description

Latest QGIS Server from OSGeo4W doesn't work. Maybe is related to Python configuration.

This are Apache environment variables used (I checked, they are valid paths):

SetEnv GDAL_DATA "C:\OSGeo4W64\share\gdal" 

SetEnv QGIS_AUTH_DB_DIR_PATH "C:\OSGeo4W64\apps\qgis\resources" 

SetEnv PYTHONHOME "C:\OSGeo4W64\apps\Python37" 

SetEnv PATH

"C:\OSGeo4W64\bin;C:\OSGeo4W64\apps\qgis\bin;C:\OSGeo4W64\apps\Qt5\bin;C:\WINDOWS\system32;C:\WINDOWS;C:\WINDOWS\System32\

S\System32\Wbem;" 

SetEnv QGIS_PREFIX_PATH "C:\OSGeo4W64\apps\qgis" 

SetEnv QT_PLUGIN_PATH "C:\OSGeo4W64\apps\qgis\qtplugins;C:\OSGeo4W64\apps\Qt5\plugins;"

Call to GetCapabilities

http://localhost:8080/cgi-bin/qgis_mapserv.fcgi.exe?SERVICE=WMS&#38;VERSION=1.3.0&#38;REQUEST=GetCapabilities

Request takes over 7 seconds and generates broken response, some text on screen but not complete XML.

Attached is QGIS Server log file only for that request.

History

#1 - 2019-01-28 01:20 PM - Giovanni Manghi

- Priority changed from Normal to High

- Affected QGIS version changed from 3.4.2 to 3.4.4

- Regression? changed from No to Yes

#2 - 2019-02-14 05:18 PM - Paul Blottiere

Hi @Uroš Preložnik,

Request takes over 7 seconds

It's very strange considering that the logfile is stating 08:33:52 INFO Server

3568

: Request finished in 118 ms.

and generates broken response, some text on screen but not complete XML.
http://localhost:8080/cgi-bin/qgis_mapserv.fcgi.exe?SERVICE=WMS&#38;VERSION=1.3.0&#38;REQUEST=GetCapabilities
#fn3568


Can you give us the text which is actually displayed? Moreover, it seems that QGIS_PROJECT_FILE environment variable is empty as well as the MAP

parameter. So the server will probably raise an exception.

Thanks for your report and send us news :).

#3 - 2019-02-14 05:25 PM - Paul Blottiere

- Status changed from Open to Feedback

#4 - 2019-02-14 08:13 PM - Uroš Preložnik

- File qgis-server-3.4.4.log added

- Status changed from Feedback to Open

- File qgis server 3.4.4 uncomplete response.xml added

Thanks for dealing with this.

Missing MAP parameter is not relevant, I always test server with plain GetCapabilities request. This should give XML reponse. So before dealing with

projects and data just check if server is working, and it doesn't in this case.

First I updated my install from 3.4.2 to 3.4.4 (QGIS Desktop+server). Problem is the same, and I'm pretty sure that something with Python is messed up.

Now I have Python27+Pythno37 (previously only 37).

I'm attaching uncomplete QGIS Server response and QGIS Server log file containing Python errors.

Hope it helps.

#5 - 2019-02-15 10:55 AM - Paul Blottiere

Hi @Uroš Preložnik,

I'm attaching uncomplete QGIS Server response and QGIS Server log file containing Python errors.

Do you have Server Python plugins?

#6 - 2019-02-15 11:09 AM - Uroš Preložnik

Paul Blottiere wrote:

Do you have Server Python plugins?

No, nothing custom. Just default setup of QGIS Desktop + server.

#7 - 2019-03-08 09:48 AM - João Gaspar

- File httpd-vhosts.conf added

- File httpd.conf added
Environment:

Windows 10 Home 64-bits

QGIS 3.4.5 Madeira 64-bits

Uros, I did a clean install with Apache Lounge Installers [https://www.apachelounge.com/download/]. I put the configurations in attach for httpd.conf and

virtualhosts.config.

Note: The correct Python paths variables need to be pointed to 3.7.

Regards,

João

#8 - 2019-03-08 09:49 AM - Giovanni Manghi

- Status changed from Open to Feedback

#9 - 2019-05-03 11:43 AM - Uroš Preložnik

Thanks João, so with your config QGIS server is running correctly, right?

I checked but nothing special, my paths are all valid also. I did another install today with latest LTR (3.4.7) but problem is the same.

What do you get if you run GetCapabilities (from your config should be something like that, correct if i wrote wrong):

http://localhost/qgis/qgis_mapserv.fcgi.exe?SERVICE=WMS&#38;VERSION=1.3.0&#38;REQUEST=GetCapabilities

Example of plain response what I can't get on Windows and is without MAP parameter is using this test server:

https://test.level2.si/cgi-bin/qgis_mapserv.fcgi?SERVICE=WMS&#38;VERSION=1.3.0&#38;REQUEST=GetCapabilities

Files

qgis-server.log 5.95 KB 2018-12-23 Uroš Preložnik

qgis server 3.4.4 uncomplete response.xml 3.99 KB 2019-02-14 Uroš Preložnik

qgis-server-3.4.4.log 7.71 KB 2019-02-14 Uroš Preložnik

httpd-vhosts.conf 2.81 KB 2019-03-08 João Gaspar

httpd.conf 20.4 KB 2019-03-08 João Gaspar
